Index: src/Actions/SelectionAction/MoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByIdAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/MoleculeByIdAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/MoleculeByIdAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "molecule.hpp"
 #include "Helpers/Log.hpp"
@@ -32,53 +30,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/MoleculeByIdAction.hpp"
 
+// and construct the stuff
+#include "MoleculeByIdAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionMoleculeByIdAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionMoleculeByIdState : public ActionState {
-public:
-  SelectionMoleculeByIdState(molecule* _mol) :
-    mol(_mol)
-  {}
-  molecule* mol;
-};
-
-const char SelectionMoleculeByIdAction::NAME[] = "select-molecule-by-id";
-
-SelectionMoleculeByIdAction::SelectionMoleculeByIdAction() :
-  Action(NAME)
-{}
-
-SelectionMoleculeByIdAction::~SelectionMoleculeByIdAction()
-{}
-
-void SelectionMoleculeById(molecule *_mol) {
-  ValueStorage::getInstance().setCurrentValue(SelectionMoleculeByIdAction::NAME, _mol);
-  ActionRegistry::getInstance().getActionByName(SelectionMoleculeByIdAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionMoleculeByIdAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionMoleculeByIdAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryMolecule(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionMoleculeByIdAction::performCall() {
-  molecule *mol = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
-
-  if (!World::getInstance().isSelected(mol)) {
-    DoLog(1) && (Log() << Verbose(1) << "Selecting molecule " << mol->name << endl);
-    World::getInstance().selectMolecule(mol);
-    return Action::state_ptr(new SelectionMoleculeByIdState(mol));
+  if (!World::getInstance().isSelected(params.mol)) {
+    DoLog(1) && (Log() << Verbose(1) << "Selecting molecule " << params.mol->name << endl);
+    World::getInstance().selectMolecule(params.mol);
+    return Action::state_ptr(new SelectionMoleculeByIdState(params));
   } else {
     return Action::success;
@@ -89,8 +52,8 @@
   SelectionMoleculeByIdState *state = assert_cast<SelectionMoleculeByIdState*>(_state.get());
 
-  if (state->mol != NULL)
-    World::getInstance().unselectMolecule(state->mol);
+  if (state->params.mol != NULL)
+    World::getInstance().unselectMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionMoleculeByIdState(state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -98,8 +61,8 @@
   SelectionMoleculeByIdState *state = assert_cast<SelectionMoleculeByIdState*>(_state.get());
 
-  if (state->mol != NULL)
-    World::getInstance().selectMolecule(state->mol);
+  if (state->params.mol != NULL)
+    World::getInstance().selectMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionMoleculeByIdState(state->mol));
+  return Action::state_ptr(state);
 }
 
@@ -115,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/MoleculeByIdAction.def
===================================================================
--- src/Actions/SelectionAction/MoleculeByIdAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/MoleculeByIdAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * MoleculeByIdAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (molecule*)
+#define paramtokens (SelectionMoleculeByIdAction::NAME)
+#define paramreferences (mol)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME MoleculeById
+#define TOKEN "select-molecule-by-id"
+
Index: src/Actions/SelectionAction/MoleculeByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByIdAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/MoleculeByIdAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class molecule;
-
-void SelectionMoleculeById(molecule *_mol);
-
-class SelectionMoleculeByIdAction : public Action {
-  friend void SelectionMoleculeById(molecule *_mol);
-
-public:
-  SelectionMoleculeByIdAction();
-  virtual ~SelectionMoleculeByIdAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "MoleculeByIdAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* MOLECULEBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/MoleculeOfAtomAction.cpp
===================================================================
--- src/Actions/SelectionAction/MoleculeOfAtomAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/MoleculeOfAtomAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/MoleculeOfAtomAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
 #include "atom.hpp"
@@ -33,54 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/MoleculeOfAtomAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionMoleculeOfAtomState : public ActionState {
-public:
-  SelectionMoleculeOfAtomState(std::vector<molecule*> selectedMolecules, atom *_Walker) :
-    selectedMolecules(selectedMolecules),
-    Walker(_Walker)
-  {}
-  std::vector<molecule*> selectedMolecules;
-  atom *Walker;
-};
-
-const char SelectionMoleculeOfAtomAction::NAME[] = "select-molecule-of-atom";
-
-SelectionMoleculeOfAtomAction::SelectionMoleculeOfAtomAction() :
-  Action(NAME)
-{}
-
-SelectionMoleculeOfAtomAction::~SelectionMoleculeOfAtomAction()
-{}
-
-void SelectionMoleculeOfAtom() {
-  ActionRegistry::getInstance().getActionByName(SelectionMoleculeOfAtomAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionMoleculeOfAtomAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionMoleculeOfAtomAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryAtom(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "MoleculeOfAtomAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionMoleculeOfAtomAction::performCall() {
-  atom *Walker = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, Walker);
+  // obtain information
+  getParametersfromValueStorage();
 
   std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
-  DoLog(1) && (Log() << Verbose(1) << "Selecting molecule to which " << Walker->getName() << " belongs." << endl);
-  World::getInstance().selectMoleculeOfAtom(Walker);
-  return Action::state_ptr(new SelectionMoleculeOfAtomState(selectedMolecules, Walker));
+  DoLog(1) && (Log() << Verbose(1) << "Selecting molecule to which " << params.Walker->getName() << " belongs." << endl);
+  World::getInstance().selectMoleculeOfAtom(params.Walker);
+  return Action::state_ptr(new SelectionMoleculeOfAtomState(selectedMolecules, params));
 }
 
@@ -92,5 +54,5 @@
     World::getInstance().selectMolecule(*iter);
 
-  return Action::state_ptr(new SelectionMoleculeOfAtomState(state->selectedMolecules, state->Walker));
+  return Action::state_ptr(_state);
 }
 
@@ -98,7 +60,7 @@
   SelectionMoleculeOfAtomState *state = assert_cast<SelectionMoleculeOfAtomState*>(_state.get());
 
-  World::getInstance().selectMoleculeOfAtom(state->Walker);
+  World::getInstance().selectMoleculeOfAtom(state->params.Walker);
 
-  return Action::state_ptr(new SelectionMoleculeOfAtomState(state->selectedMolecules, state->Walker));
+  return Action::state_ptr(_state);
 }
 
@@ -114,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/MoleculeOfAtomAction.def
===================================================================
--- src/Actions/SelectionAction/MoleculeOfAtomAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/MoleculeOfAtomAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,24 @@
+/*
+ * MoleculeOfAtomAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (atom*)
+#define paramtokens (SelectionMoleculeOfAtomAction::NAME)
+#define paramreferences (Walker)
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME MoleculeOfAtom
+#define TOKEN "select-molecule-of-atom"
+
Index: src/Actions/SelectionAction/MoleculeOfAtomAction.hpp
===================================================================
--- src/Actions/SelectionAction/MoleculeOfAtomAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/MoleculeOfAtomAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionMoleculeOfAtom();
-
-class SelectionMoleculeOfAtomAction : public Action {
-  friend void SelectionMoleculeOfAtom();
-
-public:
-  SelectionMoleculeOfAtomAction();
-  virtual ~SelectionMoleculeOfAtomAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "MoleculeOfAtomAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* MOLECULEOFATOMSACTION_HPP_ */
Index: src/Actions/SelectionAction/NotAllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllAtomsAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotAllAtomsAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
@@ -33,48 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotAllAtomsAction.hpp"
 
+// and construct the stuff
+#include "NotAllAtomsAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionNotAllAtomsAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionNotAllAtomsState : public ActionState {
-public:
-  SelectionNotAllAtomsState(std::vector<atom*> _selectedAtoms) :
-    selectedAtoms(_selectedAtoms)
-  {}
-  std::vector<atom*> selectedAtoms;
-};
-
-const char SelectionNotAllAtomsAction::NAME[] = "unselect-all-atoms";
-
-SelectionNotAllAtomsAction::SelectionNotAllAtomsAction() :
-  Action(NAME)
-{}
-
-SelectionNotAllAtomsAction::~SelectionNotAllAtomsAction()
-{}
-
-void SelectionNotAllAtoms() {
-  ActionRegistry::getInstance().getActionByName(SelectionNotAllAtomsAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotAllAtomsAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotAllAtomsAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionNotAllAtomsAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
   DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms." << endl);
   World::getInstance().clearAtomSelection();
-  return Action::state_ptr(new SelectionNotAllAtomsState(selectedAtoms));
+  return Action::state_ptr(new SelectionNotAllAtomsState(selectedAtoms, params));
 }
 
@@ -86,13 +54,13 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionNotAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr SelectionNotAllAtomsAction::performRedo(Action::state_ptr _state){
-  SelectionNotAllAtomsState *state = assert_cast<SelectionNotAllAtomsState*>(_state.get());
+  //SelectionNotAllAtomsState *state = assert_cast<SelectionNotAllAtomsState*>(_state.get());
 
   World::getInstance().clearAtomSelection();
 
-  return Action::state_ptr(new SelectionNotAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
@@ -108,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotAllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotAllAtomsAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * NotAllAtomsAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotAllAtoms
+#define TOKEN "unselect-all-atoms"
+
Index: src/Actions/SelectionAction/NotAllAtomsAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllAtomsAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionNotAllAtoms();
-
-class SelectionNotAllAtomsAction : public Action {
-  friend void SelectionNotAllAtoms();
-
-public:
-  SelectionNotAllAtomsAction();
-  virtual ~SelectionNotAllAtomsAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAllAtomsAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTALLATOMSACTION_HPP_ */
Index: src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotAllAtomsInsideCuboidAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "Descriptors/AtomShapeDescriptor.hpp"
@@ -39,90 +37,23 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotAllAtomsInsideCuboidAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionNotAllAtomsInsideCuboidState : public ActionState {
-public:
-  SelectionNotAllAtomsInsideCuboidState(std::vector<atom*> _selectedAtoms, const Vector &_position, const Vector &_extension, const double _Xangle, const double _Yangle, const double _Zangle) :
-    selectedAtoms(_selectedAtoms),
-    position(_position),
-    extension(_extension),
-    Xangle(_Xangle),
-    Yangle(_Yangle),
-    Zangle(_Zangle)
-  {}
-  std::vector<atom*> selectedAtoms;
-  Vector position;
-  Vector extension;
-  double Xangle;
-  double Yangle;
-  double Zangle;
-};
-
-const char SelectionNotAllAtomsInsideCuboidAction::NAME[] = "unselect-atoms-inside-cuboid";
-
-SelectionNotAllAtomsInsideCuboidAction::SelectionNotAllAtomsInsideCuboidAction() :
-  Action(NAME)
-{}
-
-SelectionNotAllAtomsInsideCuboidAction::~SelectionNotAllAtomsInsideCuboidAction()
-{}
-
-void SelectionNotAllAtomsInsideCuboid(const Vector &position, const Vector &extension) {
-  ValueStorage::getInstance().setCurrentValue(SelectionNotAllAtomsInsideCuboidAction::NAME, extension);
-  ValueStorage::getInstance().setCurrentValue("position", position);
-  ActionRegistry::getInstance().getActionByName(SelectionNotAllAtomsInsideCuboidAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotAllAtomsInsideCuboid(const Vector &position, const Vector &extension, const double Xangle, const double Yangle, const double Zangle) {
-  ValueStorage::getInstance().setCurrentValue(SelectionNotAllAtomsInsideCuboidAction::NAME, extension);
-  ValueStorage::getInstance().setCurrentValue("position", position);
-  ValueStorage::getInstance().setCurrentValue("angle-x", Xangle);
-  ValueStorage::getInstance().setCurrentValue("angle-y", Yangle);
-  ValueStorage::getInstance().setCurrentValue("angle-z", Zangle);
-  ActionRegistry::getInstance().getActionByName(SelectionNotAllAtomsInsideCuboidAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotAllAtomsInsideCuboidAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotAllAtomsInsideCuboidAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
-  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "NotAllAtomsInsideCuboidAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionNotAllAtomsInsideCuboidAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
-  Vector position;
-  Vector extension;
-  double Xangle = 0.;
-  double Yangle = 0.;
-  double Zangle = 0.;
   Matrix RotationMatrix;
 
-  ValueStorage::getInstance().queryCurrentValue("position", position);
-  ValueStorage::getInstance().queryCurrentValue(NAME, extension);
-  // check whether a rotation is given.
-  if (ValueStorage::getInstance().queryCurrentValue("angle-x", Xangle, true))
-    Xangle = 0.;
-  if (ValueStorage::getInstance().queryCurrentValue("angle-y", Yangle, true))
-    Yangle = 0.;
-  if (ValueStorage::getInstance().queryCurrentValue("angle-z", Zangle, true))
-    Zangle = 0.;
-  RotationMatrix.rotation(Xangle, Yangle, Zangle);
+  // obtain information
+  getParametersfromValueStorage();
+  RotationMatrix.rotation(params.Xangle, params.Yangle, params.Zangle);
 
-  DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << position << " and extension of " << extension << "." << endl);
-  Shape s = translate(transform(stretch(Cuboid(),extension),RotationMatrix),position);
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << params.position << " and extension of " << params.extension << "." << endl);
+  Shape s = translate(transform(stretch(Cuboid(),params.extension),RotationMatrix),params.position);
 
   World::getInstance().unselectAllAtoms(AtomByShape(s));
-  return Action::state_ptr(new SelectionNotAllAtomsInsideCuboidState(selectedAtoms, position, extension, Xangle, Yangle, Zangle));
+  return Action::state_ptr(new SelectionNotAllAtomsInsideCuboidState(selectedAtoms, params));
 }
 
@@ -141,6 +72,6 @@
   Matrix RotationMatrix;
 
-  RotationMatrix.rotation(state->Xangle, state->Yangle, state->Zangle);
-  Shape s = translate(transform(stretch(Cuboid(),state->extension),RotationMatrix),state->position);
+  RotationMatrix.rotation(state->params.Xangle, state->params.Yangle, state->params.Zangle);
+  Shape s = translate(transform(stretch(Cuboid(),state->params.extension),RotationMatrix),state->params.position);
   World::getInstance().unselectAllAtoms(AtomByShape(s));
 
@@ -159,2 +90,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.def
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * NotAllAtomsInsideCuboidAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class Vector;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (Vector) (Vector) (double) (double) (double)
+#define paramtokens (SelectionNotAllAtomsInsideCuboidAction::NAME) ("position") ("angle-x") ("angle-y") ("angle-z")
+#define paramreferences (extension) (position) (Xangle) (Yangle) (Zangle)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotAllAtomsInsideCuboid
+#define TOKEN "unselect-atoms-inside-cuboid"
+
Index: src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllAtomsInsideCuboidAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,30 +11,6 @@
 #include "Actions/Action.hpp"
 
-class Vector;
-
-void SelectionNotAllAtomsInsideCuboid();
-
-class SelectionNotAllAtomsInsideCuboidAction : public Action {
-  friend void SelectionNotAllAtomsInsideCuboid(const Vector &position, const Vector &extension);
-  friend void SelectionNotAllAtomsInsideCuboid(const Vector &position, const Vector &extension, const double Xangle, const double Yangle, const double Zangle);
-
-public:
-  SelectionNotAllAtomsInsideCuboidAction();
-  virtual ~SelectionNotAllAtomsInsideCuboidAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAllAtomsInsideCuboidAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTALLATOMSINSIDECUBOIDACTION_HPP_ */
Index: src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotAllAtomsInsideSphereAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "Descriptors/AtomShapeDescriptor.hpp"
@@ -38,62 +36,20 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotAllAtomsInsideSphereAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionNotAllAtomsInsideSphereState : public ActionState {
-public:
-  SelectionNotAllAtomsInsideSphereState(std::vector<atom*> _selectedAtoms, const Vector &_position, const double _radius) :
-    selectedAtoms(_selectedAtoms),
-    position(_position),
-    radius(_radius)
-  {}
-  std::vector<atom*> selectedAtoms;
-  Vector position;
-  double radius;
-};
-
-const char SelectionNotAllAtomsInsideSphereAction::NAME[] = "unselect-atoms-inside-sphere";
-
-SelectionNotAllAtomsInsideSphereAction::SelectionNotAllAtomsInsideSphereAction() :
-  Action(NAME)
-{}
-
-SelectionNotAllAtomsInsideSphereAction::~SelectionNotAllAtomsInsideSphereAction()
-{}
-
-void SelectionNotAllAtomsInsideSphere(const Vector &position, const double radius) {
-  ValueStorage::getInstance().setCurrentValue(SelectionNotAllAtomsInsideSphereAction::NAME, radius);
-  ValueStorage::getInstance().setCurrentValue("position", position);
-  ActionRegistry::getInstance().getActionByName(SelectionNotAllAtomsInsideSphereAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionNotAllAtomsInsideSphereAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionNotAllAtomsInsideSphereAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryDouble(NAME, ValueStorage::getInstance().getDescription(NAME));
-  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "NotAllAtomsInsideSphereAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionNotAllAtomsInsideSphereAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
-  double radius = 0.;
-  Vector position;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, radius);
-  ValueStorage::getInstance().queryCurrentValue("position", position);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms inside a sphere at " << position << " with radius " << radius << "." << endl);
-  Shape s = translate(resize(Sphere(),radius),position);
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting all atoms inside a sphere at " << params.position << " with radius " << params.radius << "." << endl);
+  Shape s = translate(resize(Sphere(),params.radius),params.position);
   World::getInstance().unselectAllAtoms(AtomByShape(s));
-  return Action::state_ptr(new SelectionNotAllAtomsInsideSphereState(selectedAtoms, position, radius));
+  return Action::state_ptr(new SelectionNotAllAtomsInsideSphereState(selectedAtoms, params));
 }
 
@@ -105,5 +61,5 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionNotAllAtomsInsideSphereState(state->selectedAtoms, state->position, state->radius));
+  return Action::state_ptr(_state);
 }
 
@@ -111,8 +67,8 @@
   SelectionNotAllAtomsInsideSphereState *state = assert_cast<SelectionNotAllAtomsInsideSphereState*>(_state.get());
 
-  Shape s = translate(resize(Sphere(),state->radius),state->position);
+  Shape s = translate(resize(Sphere(),state->params.radius),state->params.position);
   World::getInstance().unselectAllAtoms(AtomByShape(s));
 
-  return Action::state_ptr(new SelectionNotAllAtomsInsideSphereState(state->selectedAtoms, state->position, state->radius));
+  return Action::state_ptr(_state);
 }
 
@@ -128,2 +84,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.def
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/NotAllAtomsInsideSphereAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * NotAllAtomsInsideSphereAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class Vector;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (double) (Vector)
+#define paramtokens (SelectionNotAllAtomsInsideSphereAction::NAME) ("position")
+#define paramreferences (radius) (position)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotAllAtomsInsideSphere
+#define TOKEN "unselect-atoms-inside-sphere"
+
